package TableNested;

import java.util.ArrayList;

/**
 * All you need to do for this microlab is take the Table and Entry from the last one and make Entry a nested class.
 * Think about how nested classes should work with generics.
 */
public class TableNested<K, V> {

    private ArrayList<Entry> entries;

    public TableNested() {
        entries = new ArrayList<>();
    }

    public class Entry {
        private K key;
        private V value;

        public Entry(K key, V value) {
            this.key = key;
            this.value = value;
        }

        private K getKey() {
            return key;
        }

        private V getValue() {
            return value;
        }
    }

    public V get(K key) {
        for (Entry current : entries) {
            if (current.getKey().equals(key)) {
                return (V)current.getValue();
            }
        }
        return null;
    }

    public void put(K key, V value) {
        boolean createKey = true;
        for (int i=0; i<entries.size(); i++) {
            if (entries.get(i).getKey().equals(key)) {
                entries.set(i, new Entry(key, value));
                createKey = false;
            }
        }
        if (createKey) {
            entries.add(new Entry(key, value));
        }
    }

    public void remove(K key) {
        for (int i=0; i<entries.size(); i++) {
            if (entries.get(i).getKey().equals(key)) {
                entries.remove(i);
            }
        }
    }

}
